// ___SETA43  _____
// 19/03/2024 _____
//Mando Infrarojo LG
//Auto ruta
//Arduino 1.8.19

/*
You have to go into the .h and .cpp files and change "WProgram.h" to Arduino.h
WProgram.h: No such file or directory
*/
/*
Las librerías  "IRremote" y "RobotIRremote" son incompatibles
Tu tienes que instalar "IRremote" y desinstalar "RobotIRremote".
*/
   
  
#include <Servo.h> 

#include <IRremote.h>
#define PinIR   4

IRrecv irrecv(PinIR);
decode_results results;
int codeType = -1;

Servo myservo2;
Servo myservo3;

char direccion;
char Tauto=0;

void setup() 
{
  Serial.begin(9600);
  //while (!Serial) {;  }
  irrecv.enableIRIn(); // Start the receiver
  pinMode(13, OUTPUT);
  myservo2.attach(2);
  myservo3.attach(3);
  delay(1000);
  Serial.println("COCHE IR_rec_AUTO");
  Serial.println("=================");
  
}


void loop() 
{

  if(Tauto==1) Mauto();

  if (irrecv.decode(&results))
  {
    digitalWrite(13, HIGH);
    codeType = results.decode_type;

    switch (codeType)
    {
      case RC5:
        Serial.print("Received RC5: "); 
        Serial.println(results.value & 255);
        break;
       
      case NEC:
        Serial.print("Received NEC: "); 
         Serial.println(results.value & 255);
        //Serial.println(results.value);
        //Serial.println("-----------");
       
        switch (results.value & 255)
        {        
          case 253:
              Serial.println("253");
              Madelante();
            break;
          case 125:
              Serial.println("125");
              Matras();
            break;
          case 159:
              Serial.println("31");
              Mizquierda();
            break;
          case 31:
              Serial.println("159");
              Mderecha();
            break;
          case 221:
              Serial.println("221");
              Mstop();
              Tauto=0;
            break;
          case 61:
              Serial.println("61");
              Tauto=1;
            break;
        }
      break;
      default:
        Serial.print("Unexpected codeType ");
        Serial.print(codeType, DEC);
        Serial.println("---");
        break;
    }

    irrecv.resume(); // Receive the next value
    digitalWrite(13, LOW);
  }
  delay(20);

}


#define T_ADELANTE 0
#define T_ATRAS 180
#define T_PARAR 90


void Mauto(void)
{
  if(digitalRead(A1)==1)
    {
      myservo2.write(T_ADELANTE); 
      myservo3.write(T_ADELANTE);
    }
  if(digitalRead(A0)==1)
    {
      myservo2.write(T_ATRAS); 
      myservo3.write(T_ATRAS);
    }


  if(digitalRead(A0)==1 && digitalRead(A1)==1)
    {
      direccion=1;
      myservo2.write(T_ATRAS); 
      myservo3.write(T_ADELANTE);
    }
  
}







void Mstop(void)
{
  direccion=0;
  myservo2.write(T_PARAR); 
  myservo3.write(T_PARAR);
  //myservo2.detach();
  //myservo3.detach();
  Serial.println("--STOP--");
  digitalWrite(LED_BUILTIN, LOW);
}

void Mizquierda(void)
{ 
  myservo2.write(T_ADELANTE); 
  myservo3.write(T_ADELANTE);
  digitalWrite(LED_BUILTIN, HIGH);
  
  if(direccion!=1)
  {
    Serial.println("Izquierda");
    delay(200);
    Mstop();
  }
  else
  {
    Serial.println("Izquierda2");   
    delay(100);
    myservo2.write(T_ATRAS); 
    myservo3.write(T_ADELANTE);
  }
}

void Mderecha(void)
{
  myservo2.write(T_ATRAS); 
  myservo3.write(T_ATRAS);
  digitalWrite(LED_BUILTIN, HIGH);
  
  if(direccion!=1)
  {
    Serial.println("Derecha");
    delay(200);
    Mstop();
  }
  else
  {
    Serial.println("Derecha2");   
    delay(100);
    myservo2.write(T_ATRAS); 
    myservo3.write(T_ADELANTE);
  }  
}

void Madelante(void)
{
  direccion=1;
  myservo2.write(T_ATRAS); 
  myservo3.write(T_ADELANTE);
  Serial.println("adelante");
  digitalWrite(LED_BUILTIN, HIGH);
}

void Matras(void)
{
  direccion=-1;
  myservo2.write(T_ADELANTE); 
  myservo3.write(T_ATRAS);
  Serial.println("atras");
  digitalWrite(LED_BUILTIN, HIGH);
}
